#include <bits/stdc++.h>

using namespace std;


vector <int> manacher(string s) {
    int n = s.size();
    vector <int> res(n);

    s = "#" + s + "$";

    int i = 0, t = 0;
    while (i < n) {
        while (s[i + 1 - t] == s[i + 1 + t]) ++t;

        res[i] = t;

        int k = 1;
        while (k < t && res[i - k] != res[i] - k) {
            res[i + k] = min(res[i - k], res[i] - k);
            k++;
        }

        t = max(0, t - k);
        i += k;
    }

    return res;
}

string toString(const vector <int> &vec) {
    string res;
    for (auto b : vec) {
        res.push_back('0' + b);
    }

    return res;
}

bool check(const string &s, const vector <int> &arr) {
    return manacher(s) == arr;
}

vector <string> solve(int n, const vector <int> &arr) {
    vector <string> ans;

    for (int first = 0; first <= 1; first++) {
        for (int second = 0; second <= 1; second++) {
            vector <int> curr = {first, second};

            for (int i = 2; i < n; i++) {
                curr.push_back(curr[i-2] xor (arr[i-1] == 1));
            }

            string sCurr = toString(curr);
            if (check(sCurr, arr)) {
                ans.push_back(sCurr);
            }
        }
    }

    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;

    while (t--) {
        int n;
        cin >> n;

        vector <int> arr(n);
        for (int &x : arr) {
            cin >> x; x++;
        }

        auto ans = solve(n, arr);

        cout << ans.size() << '\n';
        for (auto &s : ans) {
            cout << s << '\n';
        }
    }
}
